package ru.landgrafhomyak.serdha.api.v0.queries

import ru.landgrafhomyak.serdha.api.v0.misc.Expression
import ru.landgrafhomyak.serdha.api.v0.LowLevelApi
import ru.landgrafhomyak.serdha.api.v0.misc.Column
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.table.Table
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseTypesProvider
import ru.landgrafhomyak.serdha.api.v0.misc.InputParam
import ru.landgrafhomyak.serdha.api.v0.misc.SelectedTable
import ru.landgrafhomyak.serdha.api.v0.runtime.ParametersSetter
import ru.landgrafhomyak.serdha.api.v0.runtime._ParametersSetter

@Suppress("ClassName")
public interface _CommonCreateQueryScope<QueryUserExtension : Any> {
	public val types: DatabaseTypesProvider

	public fun <SelectedTableUserExtension : Any> selectTable(t: Table<SelectedTableUserExtension, *>): SelectedTable<SelectedTableUserExtension, QueryUserExtension>

	public interface CanBeSubquery<@Suppress("unused") SelectedQueryUserExtension : Any>

	public interface SubqueryParametersSetter<SubqueryUserExtension : Any, QueryUserExtension : Any> : ParametersSetter<SubqueryUserExtension> {
		public operator fun <RT, DT : DatabaseType<RT>> set(c: InputParam<RT, DT, QueryUserExtension>, value: Expression<RT, DT, QueryUserExtension>)
	}

	public fun <SubqueryUserExtension : Any> selectQuery(q: CanBeSubquery<SubqueryUserExtension>, p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit): SelectedTable<SubqueryUserExtension, QueryUserExtension>

	public class SelectedDiff<SubqueryUserExtension : Any, QueryUserExtension : Any>(
		public val inserted: SelectedTable<SubqueryUserExtension, QueryUserExtension>,
		public val updated: SelectedTable<SubqueryUserExtension, QueryUserExtension>
	)

	public fun <SubqueryUserExtension : Any> selectInsert(q: InsertQuery<SubqueryUserExtension>, p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit): SelectedDiff<SubqueryUserExtension, QueryUserExtension>

	@Suppress("FunctionName")
	@LowLevelApi
	public fun <SubqueryUserExtension : Any> _selectCopy(
		q: CopyQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		r: (_ParametersSetter._Multi<InsertQuery.Creator.Scope.DataParam<SubqueryUserExtension>, Nothing>) -> Unit
	): SelectedDiff<SubqueryUserExtension, QueryUserExtension>

	@OptIn(LowLevelApi::class)
	public fun <SubqueryUserExtension : Any> selectCopyOne(
		q: CopyQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		r: (ParametersSetter<InsertQuery.Creator.Scope.DataParam<SubqueryUserExtension>>) -> Unit
	): SelectedDiff<SubqueryUserExtension, QueryUserExtension> =
		this._selectCopy(q, p, r)

	@OptIn(LowLevelApi::class)
	public fun <SubqueryUserExtension : Any, T> selectCopyMulti(
		q: CopyQuery<SubqueryUserExtension>,
		p: (SubqueryParametersSetter<SubqueryUserExtension, QueryUserExtension>) -> Unit,
		data: Iterable<T>,
		r: (T, ParametersSetter<InsertQuery.Creator.Scope.DataParam<SubqueryUserExtension>>) -> Unit
	): SelectedDiff<SubqueryUserExtension, QueryUserExtension> =
		this._selectCopy(q, p) { rr -> for (e in data) r(e, rr) }

	public fun <RT, DT : DatabaseType<RT>> param(name: String, type: DT): InputParam<RT, DT, QueryUserExtension>

	public val expressionBuilder: Expression.Builder<QueryUserExtension>

	public interface _ReturningClauseScope<QueryUserExtension : Any> {
		public fun <RT, DT : DatabaseType<RT>> returnExpression(expression: Expression<RT, DT, QueryUserExtension>): Column<RT, DT, QueryUserExtension>

		public val isDistinct: Boolean

		public fun orderBy(order: SelectQuery.Order, vararg columns: Expression<*, *, QueryUserExtension>)

		public fun groupBy(vararg columns: Expression<*, *, QueryUserExtension>)
	}
}